var FAN_LIMIT     = 15;    /* Object crawl fanout limit                 */
var MAX_LEVEL     = 4;    /* Maximum object nest level to crawl        */
var MAX_RET_LEVEL = 2;    /* Maximum ret val object level to crawl     */

var TWEAK_ODDS    = 2;    /* Property tweak probability when crawling  */
var CALL_ODDS     = 2;    /* Method call probability                   */

var REF_ODDS      = 3;    /* Object reference storing probability      */
var NONOBJ_ODDS   = 50;   /* Non-object reference storing probability  */
var INTER_ODDS    = 4;    /* Odds of using interesting_vals vs refs    */

var TRASH_ODDS    = 5;    /* Target window trashing probability        */
var RESET_ODDS    = 5;    /* Odds of respawning target windows         */

var PARAMS        = 4;    /* Number of params to make up for methods   */
var MAX_REFS      = 100;  /* Maximum number of refs to keep            */
var KEEP_REFS     = 50;  /* Number of refs to move across cycles      */


/**************************
 * Various crawl settings *
 **************************/

var interesting_vals = [
  0, 1, 1e6, -1e6, 1e-6, 1e100, null, undefined, 'pink', screen, Infinity, false, true, eval, [], {},
  4500000000, 2200000000, -2200000000, -4500000000
];

var object_blacklist = { 

  /* Properties */

  'fuzz1_visited' : 0,
  'fuzz2_visited' : 0,
  'fuzz3_visited' : 0,
  'ref_visited' : 0,

  'location' : 0,
  'name' : 0,
  'opener' : 0,
  'URL' : 0,
  'onbeforeunload' : 0,
  'onunload': 0,

  'innerHTML' : 0,
  'outerHTML' : 0,
  'innerText' : 0,
  'textContent' : 0,

  'Components': 0,
  'controllers' : 0,

  'lastChild' : 0,
  'previousSibling': 0,
  'previousElementSibling': 0,
  'parentNode' : 0,
  'parentTextEdit' : 0,
  'parentElement' : 0,
  'ownerDocument' : 0,
  'document' : 1,

  /* Methods */

  'cloneNode' : 0,
  'open' : 0,
  'close' : 0,
  'print' : 0,
  'alert': 0,
  'prompt' : 0,
  'showModalDialog' : 0,
  'confirm' : 0

};
